#ifdef USE_PCH
#include "rr_pch.h"
#endif
#pragma hdrstop
#include <sstream>
#include <iomanip>
#include "Args.h"
#include "rrUtils.h"
//---------------------------------------------------------------------------
using namespace std;
Args::Args()
:
SBMLModelsFilePath(""),
TempDataFolder("."),
EnableLogging(false),
ModelNumber(1),
ModelVersion(l2v4)
{}

string Usage(const string& prg)
{
    stringstream usage;
    usage << "\nUSAGE for "<<prg<<"\n\n";
    usage<<left;
    usage<<setfill('.');
    usage<<setw(25)<<"-m<FilePath>"                 <<" Folder where the program will read sbml models. \n";
    usage<<setw(25)<<"-t<FilePath>"                 <<" Temporary data output folder. If not given, temp files are output to current directory\n";
    usage<<setw(25)<<"-v"                           <<" Enable Logging\n";
    usage<<setw(25)<<"-i"                           <<" Test Number\n";
    usage<<setw(25)<<"-a"                           <<" ModelVersion: 0 == l2v4, 1 == l3v1\n";
    usage<<setw(25)<<"-c"                           <<" Compiler: gcc or llvm\n";
    usage<<setw(25)<<"-?"                           <<" Shows the help screen.\n\n";

    usage<<"\nSystems Biology, UW 2012\n";
    return usage.str();
}

